
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>24-oc类工厂方法和类对象基本概念 / 憋错料</title>

    <meta name="description" content="24-oc类工厂方法和类对象基本概念 类工厂方法 用于快速创建对象的类方法, 我们称之为类工厂方法 类工厂方法应用场景 类工厂方法中主要用于给对象分配存储空间和初始化这块存储空间 类工厂方法使用规范 规范: 一定是类方法 + 方法名称以类的名称开头, 首字母小写 一定有返回值, 返回值是id/instancetype 在类工厂方法实现中,调用本类的构造方法,创建实例对象,并返回实例对象 自定义类工厂方法是苹果的一个规范, 一般情况下, 我们会给一个类提供自定义构造方法和自定义类工厂方法用于创建一个对象 类工厂方法在继承中的注意点 以">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">24-oc类工厂方法和类对象基本概念</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>类工厂方法</strong></p>
<p>用于快速创建对象的类方法,&nbsp;我们称之为类工厂方法</p>
<p>类工厂方法应用场景</p>
<p>类工厂方法中主要用于给对象分配存储空间和初始化这块存储空间</p>
<p>类工厂方法使用规范</p>
<p>规范:</p>
<p>一定是类方法&nbsp;+</p>
<p>方法名称以类的名称开头,&nbsp;首字母小写</p>
<p>一定有返回值,&nbsp;返回值是id/instancetype</p>
<p>在类工厂方法实现中,调用本类的构造方法,创建实例对象,并返回实例对象</p>
<p>自定义类工厂方法是苹果的一个规范,&nbsp;一般情况下,&nbsp;我们会给一个类提供自定义构造方法和自定义类工厂方法用于创建一个对象</p>
<hr />
<br />类工厂方法在继承中的注意点</p>
<p>以后但凡自定义类工厂方法,&nbsp;在类工厂方法中创建对象一定要使用self来创建,一定不要使用类名来创建</p>
<hr />
<br /><strong>类的本质</strong></p>
<p>类其实也是一个对象,&nbsp;这个对象会在这个类第一次被使用的时候创建</p>
<p>只要有了类对象,&nbsp;将来就可以通过类对象来创建实例对象</p>
<p>实例对象中有一个isa指针,&nbsp;指向创建自己的类对象</p>
<p>类对象中保存了当前对象所有的对象方法</p>
<p>当给一个实例对象发送消息的时候,&nbsp;会根据实例对象中的isa指针去对应的类对象中查找</p>
<p>所有类对象的继承关系就是元类对象的继承关系:</p>
<p>获取类对象及类对象应用场景</p>
<p>获取类对象</p>
<p>使用class方法获取类对象</p>
<p>// [实例对象&nbsp;class];&nbsp; [类名&nbsp;class];</p>
<p>Person *p1 = [[Person alloc] init];</p>
<p>Person *p2 = [[Person alloc] init];</p>
<p>//&nbsp;一个类再内存中只有一份类对象</p>
<p>Class c1 = [p1 class];</p>
<p>Class c2 = [p2 class];</p>
<p>Class c3 = [Person class];</p>
<p>NSLog(@"c1 = %p, c2 = %p, c3 = %p", c1, c2, c3);</p>
<p>类对象的应用场景</p>
<p>用于创建实例对象</p>
<p>Person *p3 = [[c1 alloc] init];</p>
<p>p3.age =&nbsp;30;</p>
<p>NSLog(@"%i", p3.age);</p>
<p>用于调用类方法</p>
<p>[Person test];</p>
<p>[c1 test];</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 18:39:56 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>24-oc类工厂方法和类对象基本概念的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/w3vlAXM.html" rel="bookmark">自定义类工厂方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1.自定义工厂方法 什么是工厂方法(快速创建方法) 类工厂方法是一种用于分配.初始化实例并返回一个它自己的实例的类方法.类工厂方法很方便,因为它们允许您只使用一个步骤(而不是两个步骤)就能创建对象. 例如new 自定义类工厂方法的规范 (1)一定是+号开头 (2)返回值一般是instancetype类型 (3)方法名称以类名开头,首字母小写 示例 + (id)person; + (id)person { return [[Person alloc]init]; } + (id)personWit			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgRqmp4.html" rel="bookmark">OC基础（八）类工厂方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一:基本用法 类工厂方法作用:提高编码效率,快速创建对象的方法 规范:1.一定是+开头   2.方法以类名开头,首字母小写. 3.一定有返回值,返回类型为id/instancetype 比如:在类的声明和实现中 无参数: + (instancetype)person; + (instancetype)person{ return [[Person alloc] init]; } 在主函数创建对象中就可以直接使用,简化代码. Person *p1 = [Person person];  //此处的			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4Na6Qw3.html" rel="bookmark">类工厂方法及注意点</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				+(instancetype)person //p小写 { return [[self alloc] init]; } +(instancetype)personWithAge:(int)age { Person *p= [[self alloc] init]; p.age=age; return p; } 类工厂方法本质:创建一个实体类返回 注意点:创建实体类一定要用self而不是用实体类(此处是Person)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0jeBJWM.html" rel="bookmark">类工厂方法的定义</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				类工厂方法是一种用于分配.初始化实例并返回一个它自己的实例的类方法.类工厂方法很方便,因为它们允许您只使用一个步骤(而不是两个步骤)就能创建对象. 它们采用以下形式: + (type)className...(在这里 className 不包括任何前缀) 调用类工厂时如:nsstring *string = [nsstring initwithformat:@&quot;jdhj%@&quot;,anotherString]			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ONqqK0.html" rel="bookmark">9、Cocos2dx 3&period;0游戏开发三查找值小工厂方法模式和对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				重开发人员的劳动成果,转载的时候请务必注明出处:http://blog.csdn.net/haomengzhu/article/details/27704153 工厂方法模式 工厂方法是程序设计中一个经典的设计模式.指的是基类中仅仅定义创建对象的接口,将实际的实现推迟到子类中. 在这里.我们将它稍加推广,泛指一切生成并返回一个对象的静态函数. 一个经典的工厂方法如同这样: Sprite* factoryMethod() { Sprite* ret = new Sprite(); //在这里对 r			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pzD8R0.html" rel="bookmark">9、Cocos2dx 3&period;0游戏开发找小三之工厂方法模式与对象传值</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				重开发者的劳动成果,转载的时候请务必注明出处:http://blog.csdn.net/haomengzhu/article/details/27704153 工厂方法模式 工厂方法是程序设计中一个经典的设计模式,指的是基类中只定义创建对象的接口,将实际的实现推迟到子类中. 在这里,我们将它稍加推广,泛指一切生成并返回一个对象的静态函数. 一个经典的工厂方法如同这样: Sprite* factoryMethod() { Sprite* ret = new Sprite(); //在这里对 ret			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4pKvYJ3.html" rel="bookmark">类的属性、类的方法、类的内置方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				类的属性 变量在类中称为类的属性,函数在类中称为类的方法,类的属性分为以下几种: (1) 公有属性:在类中和类外都能调用的属性,定义的时候与变量的定义一致,如 color = 'yellow'(2) 私有属性:不能在类外及被类以外的函数调用,定义的时候以双下划线开头,如__color = 'yellow' (3) 内置属性: 由系统在定义类的时候默认添加的,定义的时候以前后双下划线构成,如 dict #!/usr/bin/env python class People(object): colo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0kGJdj0.html" rel="bookmark">oc基础第一天---类的方法，类与对象</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. 如何为类定义行为. 刚刚我们聊的是如何为类定义特征. 如何定义行为? 行为就事1个功能 也就事1个函数. OC中把行为叫做方法. 实际上和函数是一样的 代表1个功能模块. 2. 为类定义无参数的方法. 类的方法也分为两个部分. a. 方法的声明 1). 位置: 写在声明类的大括弧的外边. 2). 声明的语法: - (返回值类型)方法名; - (void)sayHi; 这个方法的名字就叫做sayHi; b. 方法的实现. 1). 位置: 写在类的实现之中. 2). 实现的语法: - (返回值			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgqwRO3.html" rel="bookmark">java匿名类工厂方法&lbrack;java编程思想10&period;6&period;1&rsqb;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				package com.ebao.java.innerclass; public interface Service { void method1(); void method2();} public interface ServiceFactory { Service getService();} public class Implementation1 implements Service { private Implementation1(){} @Override public void			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/g418dO3.html" rel="bookmark" class="title">实时的分布式搜索和分析引擎&mdash;&mdash;Elasticsearch</a>
					<div>
						Elasticsearch是一个基于Apache Lucene(TM)的开源搜索引擎.无论在开源还是专有领域,Lucene可以被认为是迄今为止最先进.性能最好的.功能最全的搜索引擎库. 但是,Luce ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Q0xw2BM.html" rel="bookmark" class="title">sqlmap用户手册 &vert; WooYun知识库</a>
					<div>
						sqlmap用户手册 说明:本文为转载,对原文中一些明显的拼写错误进行修正,并标注对自己有用的信息. 原文:http://drops.wooyun.org/tips/143 ============= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/v0kEmj4.html" rel="bookmark" class="title">【BZOJ-1924】所驼门王的宝藏    Tarjan缩点（&plus;拓扑排序） &plus;  拓扑图DP</a>
					<div>
						1924: [Sdoi2010]所驼门王的宝藏 Time Limit: 5 Sec  Memory Limit: 128 MBSubmit: 787  Solved: 318[Submit][Stat ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35VXYv4.html" rel="bookmark" class="title">display&colon;inline、block、inline-block的区别</a>
					<div>
						block元素的特点是: 元素另起一行: 行宽高边距可控制: &lt;div&gt;, &lt;p&gt;, &lt;h1&gt;, &lt;form&gt;, &lt;ul&gt; 和 &lt;li ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wRA710.html" rel="bookmark" class="title">赋值，copy和deepcopy</a>
					<div>
						python的复制,拷贝,和深拷贝. &gt;&gt;&gt; a=[23,3]&gt;&gt;&gt; b=a&gt;&gt;&gt; b.append(234)&gt;&gt;&gt; a[23, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RYPQPM.html" rel="bookmark" class="title">关于JSONP以及跨域相关</a>
					<div>
						什么是跨域: 浏览器对ajax请求的限制,不允许跨域请求资源. http://www.a.com---&gt;http://www.b.com       是跨域 http://www.a.com-- ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nvB770.html" rel="bookmark" class="title">自学linux符号总结</a>
					<div>
						linux符号总结    简单   易用  高效 :            多个命令的分隔符 /              根或者路劲的分隔符 &gt;             标准输出重定向(数据流 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NaXew3.html" rel="bookmark" class="title">oracle 常用相关sql 语句</a>
					<div>
						一.oracle 常用相关sql 语句 1. 连接数据库       su - oracle -c &quot; sqlsplus 用户/密码     注:首次登陆用  sqlplus / as sy ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JY25b3.html" rel="bookmark" class="title">你的笔记本需要整理么</a>
					<div>
						笔记本从前还不算乱.但是 随着学习的深入,文件增多.感觉好多东西 不知道放哪个文件下合适,有一些需要的东西 又要找半天. 我迫切的要改变现状.所以 前两天又把&lt;你的知识需要管理&gt;看了一遍, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JyO1b3.html" rel="bookmark" class="title">Install your Application into RaspberryPi2 and automatically start up</a>
					<div>
						如何安装和卸载应用程序到RaspberryPi2? 如何配置应用程序在RaspberryPi2开机后自动启动? How to install your app into RaspberryPi2? H ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mo52gP3.html" rel="bookmark" class="title">phpredis中文手册&mdash;&mdash;《redis中文手册》 php版（转）</a>
					<div>
						redis中文手册:http://readthedocs.org/docs/redis/en/latest/ 本文是参考&lt;redis中文手册&gt;,将示例代码用php来实现,注意php-red ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXqnY80.html" rel="bookmark" class="title">Bia 娘 js 教程第一讲&mdash;&mdash;&OpenCurlyDoubleQuote;亲爱的，我们来聊聊天&rdquo;</a>
					<div>
						JavaScript 一种直译式脚本语言,是一种动态类型.弱类型.基于原型的语言,内置支持类型.它的解释器被称为 JavaScript 引擎,为浏览器的一部分,广泛用于客户端的脚本语言,最早是在 HT ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Myobwm3.html" rel="bookmark" class="title">SQL常用性能统计语句</a>
					<div>
						1.查看SQL语句IO消耗 set statistics io on     sql 语句 set statistics io off 2.查看SQL语句时间消耗 set statistics tim ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MmmBqnM.html" rel="bookmark" class="title">漫谈如何学习操作系统原理</a>
					<div>
						本人学习计算机技术至今,对于如何学习操作系统原理有一点自己的看法,现在写出来,希望对大家能有所助! 操作系统怎么学,首先要想操作系统是怎么来的,在没有操作系统的年代里,人们是怎么编程的.这是首要的问  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pkrv83.html" rel="bookmark" class="title">linux下手动安装apache详解</a>
					<div>
						操作系统:ubuntu12.04 前言:    linux下,默认安装软件,在开发过程中会经常不知道到什么路径下找到所需的程序,因此手动安装程序对后续的使用会提供非常大的便利.在此,以安装apache ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pkxGV3.html" rel="bookmark" class="title">python flask下传数据到js</a>
					<div>
						首先要清楚后台和前端交互所采用的数据格式.一般选JSON,因为和js完美贴合. 后台返回的数据进行序列化 在/homepageRecommend 路由的 view方法中返回序列化数据 dict = { ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXDZPQM.html" rel="bookmark" class="title">【Servlet】Filter深入讲解及实例研究</a>
					<div>
						林炳文Evankaka原创作品.转载请注明出处http://blog.csdn.net/evankaka 一.Filter 1.过滤器的概念 Java中的Filter 并不是一个标准的Servlet  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0e6Gqa3.html" rel="bookmark" class="title">win命令整理</a>
					<div>
						1.Netstat用于显示与IP.TCP.UDP和ICMP协议相关的统计数据,一般用于检验本机各端口的网络连接情况. netstat -ano 查看端口占用命令 查看被占用端口对应的PID, nets ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0KPRY93.html" rel="bookmark" class="title">【ztree系列&mdash;&mdash;图标的修改】Bootstrap风格的ztree</a>
					<div>
						前段时间项目中需要用树形结构,在选取的时候参考了很多插件,经过很多尝试,最后又回归到了ztree上.以前用的界面框架是EasyUI,但是它的树结构在实现起来有点复杂,并且功能不是特别完善.dtree在 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41nWeJM.html" rel="bookmark" class="title">解决 Swiper 插件autoHeight问题 建议</a>
					<div>
						var mySwiper=$(&quot;.swiper-container&quot;).swiper({ autoHeight: true, onSlideChangeStart: functio ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.028 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
